(   "-"    .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
)

0 CONSTANT FALSE ( -- false ) \ 94 CORE EXT
\   "".

-1 CONSTANT TRUE ( -- true ) \ 94 CORE EXT
\   "",     .

4 CONSTANT CELL

: */ ( n1 n2 n3 -- n4 ) \ 94
\  n1  n2,     d.
\  d  n3,   n4.
  */MOD NIP
;

: CHAR+ ( c-addr1 -- c-addr2 ) \ 94
\     c-addr1   c-addr2.
  1+
;
: CHARS ( n1 -- n2 ) \ 94
\ n2 -  n1 .
; IMMEDIATE

: MOVE ( addr1 addr2 u -- ) \ 94
\  u  ,   u   addr1  addr2.
\  MOVE  u    addr2     ,
\    u    addr1  .
  >R 2DUP SWAP R@ + U< \       
  IF 2DUP U<           \   
     IF R> CMOVE> ELSE R> CMOVE THEN
  ELSE R> CMOVE THEN ;

: ERASE ( addr u -- ) \ 94 CORE EXT
\  u  ,      u  ,
\    addr.
  0 FILL ;

: BLANK ( addr len -- )     \ fill addr for len with spaces (blanks)
  BL FILL ;

: DABS ( d -- ud ) \ 94 DOUBLE
\ ud   d.
  DUP 0< IF DNEGATE THEN
;

255 CONSTANT MAXCOUNTED   \ maximum length of contents of a counted string

\ : 0X BASE @ HEX >R BL WORD ?LITERAL
\      R> BASE ! ; IMMEDIATE
: "CLIP"        ( a1 n1 -- a1 n1' )   \ clip a string to between 0 and MAXCOUNTED
                MAXCOUNTED MIN 0 MAX ;

: PLACE         ( addr len dest -- )
                SWAP "CLIP" SWAP
                2DUP 2>R
                CHAR+ SWAP MOVE
                2R> C! ;

: +PLACE        ( addr len dest -- ) \ append string addr,len to counted
                                     \ string dest
                >R "CLIP" MAXCOUNTED  R@ C@ -  MIN R>
                                        \ clip total to MAXCOUNTED string
                2DUP 2>R

                COUNT CHARS + SWAP MOVE
                2R> +! ;

: C+PLACE       ( c1 a1 -- )    \ append char c1 to the counted string at a1
                DUP 1+! COUNT + 1- C! ;


: STR>R ( addr u -- addr1 u)
\   addr u   
\  addr1   
;

: HH. DUP  \ R-_-_ EAX
 >R HPOINT RDROP
 DROP ;

0  VALUE  DOES-CODE
' _USER-VALUE-CODE VALUE USER-VALUE-CODE
'  _TOUSER-VALUE-CODE  VALUE TOUSER-VALUE-CODE


: $!         ( addr len dest -- )
   PLACE ;

: ASCII-Z     ( addr len buff -- buff-z )        \ make an ascii string
   DUP >R $! R> COUNT OVER + 0 SWAP C! ;

: 0MAX 0 MAX ;

: R>     ['] C-R>    INLINE, ;   IMMEDIATE
: >R     ['] C->R    INLINE, ;   IMMEDIATE

: 2CONSTANT  ( d --- )
\ Create a new definition that has the following runtime behavior.
\ Runtime: ( --- d) push the constant double number on the stack. 
  CREATE HERE 2! 8 ALLOT DOES> 2@ ;

: OFF 0 SWAP ! ;
: ON -1 SWAP ! ;

